unit main;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
interface
uses
 mseglob,mseguiglob,mseguiintf,mseapplication,msestat,msemenus,msegui,
 msegraphics,msegraphutils,mseevent,mseclasses,mseforms,msetabs,msewidgets,
 msesimplewidgets,msedataedits,mseedit,msestrings,msetypes,msegraphedits,
 msesplitter,msegrids,msewidgetgrid,msedatanodes,mselistbrowser,msewindowwidget,
 sysutils, alsmplayer, functions, playlists, classes, inifiles,mseimage,
 msebitmap,msefiledialog,msescrollbar,msesys,msetimer, msegridsglob;

type
 tmynode = class(ttreelistedititem)   //for media libraries
  private
   fint: integer;
   fstr: msestring;
  public
   property int: integer read fint write fint;
   property str: msestring read fstr write fstr;
 end; 
 
type
 tmainfo = class(tmainform)
   ttabwidget1: ttabwidget;
   ttabpage1: ttabpage;
   ttabpage2: ttabpage;
   ttabpage4: ttabpage;
   ttabpage5: ttabpage;
   ttabwidget3: ttabwidget;
   ttabpage9: ttabpage;
   tlabel5: tlabel;
   tlabel6: tlabel;
   tlabel7: tlabel;
   tlabel8: tlabel;
   tlabel9: tlabel;
   ttabpage10: ttabpage;
   tlabel10: tlabel;
   ttabpage11: ttabpage;
   be_nexttrackallow: tbooleanedit;
   tbooleanedit2: tbooleanedit;
   tlabel24: tlabel;
   sl_speed: tslider;
   tlabel4: tlabel;
   dd_cache: tdropdownlistedit;
   tlabel3: tlabel;
   dd_vo: tdropdownlistedit;
   tlabel21: tlabel;
   dd_ao: tdropdownlistedit;
   tlabel20: tlabel;
   tspacer5: tspacer;
   l_playlist_count: tlabel;
   tlabel12: tlabel;
   s_video: tspacer;
   tlabel14: tlabel;
   tlabel16: tlabel;
   ww_videoout: twindowwidget;
   s_bottom: tspacer;
   l_pos: tlabel;
   l_status: tlabel;
   s_playlist: tspacer;
   l_title: tlabel;
   tbutton15: tbutton;
   s_top: tspacer;
   b_showplaylist: tbutton;
   b_0: tbutton;
   b_1: tbutton;
   b_2: tbutton;
   s_playbuttons: tspacer;
   b_prev: tbutton;
   b_play: tbutton;
   b_stop: tbutton;
   b_next: tbutton;
   ttabwidget4: ttabwidget;
   ttabpage12: ttabpage;
   ttabpage13: ttabpage;
   tspacer2: tspacer;
   tbutton8: tbutton;
   tbutton9: tbutton;
   tbutton10: tbutton;
   be_repeatplaylist: tbooleanedit;
   tbutton5: tbutton;
   tbutton12: tbutton;
   sg: tstringgrid;
   tlabel25: tlabel;
   tlabel22: tlabel;
   tlabel23: tlabel;
   tlabel19: tlabel;
   tlabel18: tlabel;
   tbutton16: tbutton;
   l_havevideo: tlabel;
   tbooleanedit3: tbooleanedit;
   timage1: timage;
   sl_saturation: tslider;
   sl_hue: tslider;
   sl_gamma: tslider;
   sl_contrast: tslider;
   sl_brightness: tslider;
   sl_position: tslider;
   tspacer8: tspacer;
   tlabel26: tlabel;
   tbutton4: tbutton;
   sl_balance: tslider;
   sl_volume: tslider;
   be_shufle: tbooleanedit;
   tfiledialog1: tfiledialog;

   (* FORM *)   
   b_fullscreen: tbutton;
   sg_pl: tstringgrid;
   sg_debug: tstringgrid;
   tbutton3: tbutton;
   tbutton6: tbutton;
   tbooleanedit4: tbooleanedit;
   tlabel27: tlabel;
   e_mplayer: tedit;
   b_4: tbutton;
   b_3: tbutton;
   tbutton2: tbutton;
   tbutton7: tbutton;
   ttabpage8: ttabpage;
   manageTv: tgroupbox;
   tbutton11: tbutton;
   tbutton17: tbutton;
   tlabel11: tlabel;
   e_normtv: tdropdownlistedit;
   tlabel13: tlabel;
   e_freqtv: tintegeredit;
   tbutton18: tbutton;
   e_tvname: tstringedit;
   tlabel28: tlabel;
   st: tstringgrid;
   b_pl: tbutton;
   ttabpage14: ttabpage;
   ttabwidget2: ttabwidget;
   ttabpage6: ttabpage;
   tspacer3: tspacer;
   l_radio_count: tlabel;
   tlabel1: tlabel;
   grid: twidgetgrid;
   tree: ttreeitemedit;
   tspacer6: tspacer;
   l_radiochenelscount: tlabel;
   tlabel15: tlabel;
   ttabpage7: ttabpage;
   tspacer4: tspacer;
   l_tv_count: tlabel;
   tlabel2: tlabel;
   grid2: twidgetgrid;
   tree2: ttreeitemedit;
   tspacer7: tspacer;
   l_tvchenelscount: tlabel;
   tlabel17: tlabel;
   tspacer1: tspacer;
   tbutton13: tbutton;
   tbutton14: tbutton;
   tlabel29: tlabel;
   tbutton19: tbutton;
   tlabel30: tlabel;
   e_cmd: tedit;
   tbutton20: tbutton;
   tlabel31: tlabel;
   tlabel32: tlabel;
   procedure on_create(const sender: TObject);
   procedure resizevideo(screenwidth, screenheight : integer);
   procedure on_resize(const sender: TObject);
   procedure on_chooseTab(const sender: TObject);
   procedure on_showplaylist(const sender: TObject);

   (* player management *)
   procedure on_prev(const sender: TObject);
   procedure on_stop(const sender: TObject);
   procedure on_play(const sender: TObject);
   procedure on_next(const sender: TObject);
   procedure on_fullscreen(const sender: TObject);
   procedure on_setvolume(const sender: TObject; var avalue: realty;var accept: Boolean);
   procedure on_setposition(const sender: TObject; var avalue: realty; var accept: Boolean);
      
   (* VIDEO SETTINGS *)
   procedure on_showvideosettings(const sender: TObject);
   procedure on_setsetbrightness(const sender: TObject; var avalue: realty; var accept: Boolean);
   procedure on_setcontrast(const sender: TObject; var avalue: realty; var accept: Boolean);
   procedure on_setgamma(const sender: TObject; var avalue: realty; var accept: Boolean);
   procedure on_sethue(const sender: TObject; var avalue: realty;var accept: Boolean);
   procedure on_setsaturation(const sender: TObject; var avalue: realty;var accept: Boolean);
   procedure on_setvideooptionstodefault(const sender: TObject);
   
   (* player events *)
   procedure on_Status(const Sender : TObject; currentstatus : string; position, length : integer);
   procedure on_StartPlayEvent(const Sender :TObject; screenwidth, screenheight, volume : integer);
   procedure on_EndOfTrackevent(const Sender : TObject; currentstatus : string; position, length : integer);
   procedure on_GetDebugMessage(const Sender :TObject; msg : AnsiString);
   
   (* playlist *)
   procedure on_addfilestoplaylist(const sender: TObject);
   procedure addfile(fname : msestring);
   procedure on_deleteformplaylist(const sender: TObject);
   procedure on_clearplaylist(const sender: TObject);
   procedure on_upTrackInPlaylist(const sender: TObject);
   procedure on_downTrackInPlaylist(const sender: TObject);
   procedure updatepl;
   procedure on_setrepeatplaylist(const sender: TObject; var avalue: Boolean; var accept: Boolean);
   procedure on_dblclickeventonplaylist(const sender: TObject; var info: celleventinfoty);
   procedure on_setbalance(const sender: TObject; var avalue: realty;var accept: Boolean);
   procedure on_openplaylist(const sender: TObject);
   procedure on_shuffleplaylist(const sender: TObject; var avalue: Boolean; var accept: Boolean);

   (* my playlists *)
   procedure loadplaylists(const sender : tobject);
   procedure delete_playlist_form_list(const sender: TObject);
   
   (* settings *)
   procedure on_setNextTrackAllow(const sender: TObject; var avalue: Boolean;var accept: Boolean);
   procedure on_setindexing(const sender: TObject; var avalue: Boolean; var accept: Boolean);
   procedure on_allowalwayscaching(const sender: TObject; var avalue: Boolean; var accept: Boolean);
   procedure on_setaudioOutput(const sender: TObject; var avalue: msestring; var accept: Boolean);
   procedure on_setvideooutput(const sender: TObject; var avalue: msestring; var accept: Boolean);
   procedure on_setcache(const sender: TObject; var avalue: msestring; var accept: Boolean);
   procedure on_choosemplayer(const sender: TObject);
   procedure on_addtodebugmplayeroutput(const sender: TObject; var avalue: Boolean; var accept: Boolean);

   (* on-line chanels *)
   procedure loadchanels; // enter point
   procedure loadchanelsfile(fname : string);    
   procedure on_choosechanel(const sender: TObject; var info: celleventinfoty);
   procedure onchooseplaylistformmyplaylists(const sender: TObject; var info: celleventinfoty);
   procedure on_openplaylist_from_myplaylists(const sender: TObject);
   
   (* TV *)
   procedure _on_showtvchannellist(const sender: TObject);
   procedure on_addchanell(const sender: TObject);
   procedure on_deletechanell(const sender: TObject);
   procedure on_setchanneltv(const sender: TObject);   
   procedure on_dblclickeventonplaylist2(const sender: TObject;
                   var info: celleventinfoty);
   procedure on_terminatequery(var terminate: Boolean);
   procedure on_showonline(const sender: TObject);
   procedure on_cleardebug(const sender: TObject);
   procedure on_sendcmdtomplayer(const sender: TObject);
 end;

const
  CFGChannelsName='channelstv.ini';    

var    mainfo : tmainfo;
       player : tmplayer; 
   fullscreen : boolean;
      appname : string = 'xel Player';
      version : string = 'version 0.10.1 alfa';   
    separator : char = {$ifdef mswindows}'\'{$endif}{$ifdef linux}'/'{$endif}; 
     sl_debug : tstringlist;
          SC : Tinifile;
CountSelectionGrid : Integer; 
 radiochanelscount,
    tvchanelscount :  integer;   

implementation
uses
 main_mfm;

function StrToTvNorm(NormStr:string):tvnorm;
var I:tvnorm;
begin
 Result:=SECAM_DK;
 for I in TvNorm do
   begin
     if Tvstr[I]=NormStr then 
         begin 
            Result:=I; 
            exit; 
         end;
   end;
end; 
 
// ======================================================= 
//               FORM
// ======================================================= 
// ======================================================= 
//               create form
// ======================================================= 
procedure tmainfo.on_create(const sender: TObject);
var i : integer;
    s : msestring;
  Itv : TTVData;    
  str : string;
begin
  (* some settings for widgets*)
  s_top.top := 0;
  l_pos.caption := ' 00:00:00 / 00:00:00';
  caption := appname + ' ' + version;
  s_playlist.visible := false;
  s_video.bounds_cx := width;
  (* TMPLATYER*)
  player := tmplayer.create;
  player.display := ww_videoout;
  player.Status := @on_Status;
  player.onStartPlay := @on_StartPlayEvent;
  player.onEndTrack := @on_EndOfTrackEvent;
  player.onGetDebugMessage := @on_GetDebugMessage; 

  for i := 0 to player.audiooutputlist.count - 1 do 
      dd_ao.dropdown.cols.addrow(msestring(player.audiooutputlist[i]));
  dd_ao.value := player.audiooutputlist[0];   

  for i := 0 to player.videooutputlist.count - 1 do 
      dd_vo.dropdown.cols.addrow(msestring(player.videooutputlist[i]));
  dd_vo.value := player.videooutputlist[0];   

  s := '128';  dd_cache.dropdown.cols.addrow(s);
  s := '256';  dd_cache.dropdown.cols.addrow(s);
  s := '512';  dd_cache.dropdown.cols.addrow(s);
  s := '1024'; dd_cache.dropdown.cols.addrow(s);
  s := '2048'; dd_cache.dropdown.cols.addrow(s);
  s := '4096'; dd_cache.dropdown.cols.addrow(s);
  dd_cache.value := '1024';  
 
  e_mplayer.text := player.mplayer;
    
  loadplaylists(sender); 
  loadchanels;  
  sl_debug := tstringlist.create;
  
  sc:=TIniFile.Create(CFGChannelsName);
  for i:=1 to sc.ReadInteger('TVcount','Count',0) do
  begin
  Itv.Freq:=sc.ReadInteger('TV'+inttostr(i),'freqtv',45);
  str:=Sc.ReadString('TV'+inttostr(i),'normtv','SECAM-DK');
  Itv.Norm:=StrToTvNorm(str);
  Itv.Name:=sc.ReadString('TV'+inttostr(i),'tvname','TV');
  player.ListofChanell.AddItem(Itv);
  st.rowcount := st.rowcount + 1;
  st.datacols[0][st.rowcount-1]:=Itv.Name;
  st.datacols[1][st.rowcount-1] :=inttostr(Itv.Freq) ;
  st.datacols[2][st.rowcount-1]:=str;
  end;
  sc.free;  
  
  for i := 1 to ParamCount do 
    begin 
      addfile(ParamStr(i));
      on_play(sender); 
    end;  
    
end;

// ======================================================= 
//               resize form
// ======================================================= 
procedure tmainfo.on_resize(const sender: TObject);
begin
  if player.mode <> __tv then resizevideo(player.currenttrack.videoresolution.x,
			                              player.currenttrack.videoresolution.y);
  if player.mode = __tv then  resizevideo(640,480);
end;

procedure tmainfo.on_terminatequery(var terminate: Boolean);
begin
 player.stop;
end;

// ======================================================= 
//               resize video out
// ======================================================= 
procedure tmainfo.resizevideo(screenwidth, screenheight : integer);
var r : real;
    t : integer;
begin
  if s_top.visible 
     then t := s_top.height
     else t := 0;
     
  ww_videoout.top := t;
  ww_videoout.left := 0;
      
  if screenheight = 0 then 
    begin
      ww_videoout.width := 0;
      ww_videoout.height := 0;
      exit; 
    end;
    
  if s_top.visible 
     then ww_videoout.height := s_video.height - s_top.height
     else ww_videoout.height := s_video.height;

  r := screenwidth / screenheight;
  ww_videoout.width  := round(ww_videoout.height * r);

  if ww_videoout.width < s_video.width
     then ww_videoout.left := (s_video.width - ww_videoout.width) div 2
     else begin
    	     ww_videoout.width := s_video.width;
 	         ww_videoout.height := round(ww_videoout.width / r);
    	     ww_videoout.top := ((height - s_bottom.height) - ww_videoout.height) div 2;
	      end;
end;



procedure tmainfo.on_chooseTab(const sender: TObject);
begin
 ttabwidget1.activepageindex := strtoint(copy((sender as tbutton).name,3,1));
// if ttabwidget1.activepageindex = 0 
//    then b_showplaylist.visible := true
//    else b_showplaylist.visible := false;
end;


// ======================================================= 
//               ALSMPLAYER EVENTS 
// ======================================================= 
// ======================================================= 
//               get debug message
// ======================================================= 
procedure tmainfo.on_GetDebugMessage(const Sender :TObject; msg : AnsiString);
var i : integer;
    s : msestring;
begin
    sl_debug.clear;
    sl_debug.text := msg;
    for i := 0 to sl_debug.count - 1 do
    begin
	sg_debug.rowcount := sg_debug.rowcount + 1;
	s := sl_debug[i]; 
	if substrpos('ALSMPLAYER : MPLAYER : ',s) > 0 
	  then delete(s ,1,length('ALSMPLAYER : MPLAYER : '));
	sg_debug.datacols[0][sg_debug.rowcount - 1] := s;
	sg_debug.row := sg_debug.rowcount - 1;
	end;
end;

// ======================================================= 
//               status event (connect, play, pause, etc)
// ======================================================= 
procedure tmainfo.on_Status(const Sender : TObject; currentstatus : string; position, length : integer);
begin
  l_status.caption := currentstatus;
 
  if length = 0 then length := 1;
  sl_position.value := position / length;
  l_pos.caption := SecondsToFmtStr(position) + ' / ' + SecondsToFmtStr(length);
 
  if currentstatus = 'Play' 
     then b_play.caption := '||'
     else b_play.caption := pchar('>');
end;

// ======================================================= 
//               start play event
// ======================================================= 
procedure tmainfo.on_StartPlayEvent(const Sender :TObject; screenwidth, screenheight, volume : integer);
var i : integer;
begin
 ww_videoout.left  := 0;
 ww_videoout.top   := 0; 
 ww_videoout.width  := 0;
 ww_videoout.height := 0; 
 l_status.caption := pchar('Starting play ...');
 l_title.caption := extractfilename(player.currenttrack.filename);

 if sg.rowcount > 0 then   
   for i := 0 to sg.rowcount - 1 do 
      if i = main.player.tracknum 
        then sg.datacols[0][i] := pchar('>')
        else sg.datacols[0][i] := ''; 
        
 resizevideo(screenwidth, screenheight);   
 player.setspeed(round(sl_speed.value * 10) - 4);
 sl_brightness.value := 0.5;
 sl_contrast.value := 0.5;
 sl_gamma.value := 0.5;
 sl_hue.value := 0.5;
 sl_saturation.value := 0.5;
end;

// ======================================================= 
//               End Of Track event
// ======================================================= 
procedure tmainfo.on_EndOfTrackEvent(const Sender :TObject; currentstatus : string; position, length : integer);
begin
  b_play.caption := pchar('>');
  l_status.caption := 'End Of Track';
  ww_videoout.left  := 0;
  ww_videoout.top   := 0; 
  ww_videoout.width  := 0;
  ww_videoout.height := 0; 
end;

// ======================================================= 
//               PLAYER MANAGEMENT
// ======================================================= 
// ======================================================= 
//               prev 
// ======================================================= 
procedure tmainfo.on_prev(const sender: TObject);
begin player.prev; 
end;

// ======================================================= 
//               stop 
// ======================================================= 
procedure tmainfo.on_stop(const sender: TObject);
begin player.stop;
end;

// ======================================================= 
//               play 
// ======================================================= 
procedure tmainfo.on_play(const sender: TObject);
begin
  if player.playing
	 then player.pause
	 else begin
	          player.setvolume(round(sl_volume.value * 100)); // if we change volume while not play
	          player.play;
	      end; 
end;

// ======================================================= 
//               next 
// ======================================================= 
procedure tmainfo.on_next(const sender: TObject);
begin player.next;
end;

// ======================================================= 
//               fullscreen
// ======================================================= 
procedure tmainfo.on_fullscreen(const sender: TObject);
begin
  fullscreen := not fullscreen;
  if fullscreen 
     then mainfo.options := mainfo.options + [fo_fullscreen] - [fo_defaultpos]
	 else mainfo.options := mainfo.options - [fo_fullscreen] + [fo_defaultpos];
end;

// ======================================================= 
//               set volume 
// ======================================================= 
procedure tmainfo.on_setvolume(const sender: TObject; var avalue: realty; var accept: Boolean);
begin
  player.setvolume(round(avalue * 100));
end;

// ======================================================= 
//               set position
// ======================================================= 
procedure tmainfo.on_setposition(const sender: TObject; var avalue: realty; var accept: Boolean);
begin
  player.gotoposition( round(avalue * player.lengthsec) ); 
end;


// ======================================================= 
//               set balance
// ======================================================= 
procedure tmainfo.on_setbalance(const sender: TObject; var avalue: realty;var accept: Boolean);
begin
 sl_balance.hint := inttostr (round (avalue * 100) );
 player.setbalance( round ((avalue * 2 - 1) * 100) ); 
end;


// ======================================================= 
//               PLAYLIST
// =======================================================  
// ======================================================= 
//               show or hide playlist
// =======================================================  
procedure tmainfo.on_showplaylist(const sender: TObject);
begin
 if ttabwidget1.activepageindex <> 0
    then begin
          ttabwidget1.activepageindex := 0;
          s_playlist.visible := true;
          ttabwidget4.activepageindex := 0;
          s_video.bounds_cx := width - s_playlist.bounds_cx;
          exit;
         end; 

 if  ttabwidget4.activepageindex = 0 
    then s_playlist.visible := not s_playlist.visible
    else s_playlist.visible := true;

 ttabwidget4.activepageindex := 0;
 if s_playlist.visible 
   then s_video.bounds_cx := width - s_playlist.bounds_cx
   else s_video.bounds_cx := width;
 s_playbuttons.visible := true;
 on_resize(sender);   
end;


// ======================================================= 
//               add file(s) to playlist                   
// ======================================================= 
procedure tmainfo.on_addfilestoplaylist(const sender: TObject);
var s : array of msestring;
    i : integer;
begin
 if tfiledialog1.execute = mr_Ok then
 begin
   s := tfiledialog1.controller.filenames;
   for i := 0 to high(s) do addfile(s[i]);
 end;
// sb_submenu.visible := false; 
end;

// ======================================================= 
//               add file to playlist
// ======================================================= 
procedure tmainfo.addfile(fname : msestring);
begin
  {$ifdef mswindows}
  if fname[1] = '/' then delete(fname,1,1);
  {$endif}  
  sg.rowcount := sg.rowcount + 1;
  sg.datacols[1][sg.rowcount - 1] := extractfilename(fname);
  sg.datacols[2][sg.rowcount - 1] := fname;
  updatepl;
end;

// ======================================================= 
//               delete from playlist                      
// ======================================================= 
procedure tmainfo.on_deleteformplaylist(const sender: TObject);
begin
 sg.deleterow(sg.row);
 updatepl;
end;


// ======================================================= 
//               move track up in playlist
// ======================================================= 
procedure tmainfo.on_upTrackInPlaylist(const sender: TObject);
begin
 if sg.row > 0
 then
  begin
   sg.moverow(sg.row,sg.row - 1);
//   player.tracknum := player.tracknum - 1;
//   if sg.datacols[0][sg.row] = '      >' then player.tracknum := player.tracknum - 1;
   updatepl;
  end; 
end;

// ======================================================= 
//               move track down in playlist
// ======================================================= 
procedure tmainfo.on_downTrackInPlaylist(const sender: TObject);
begin
 if sg.row < sg.rowcount -1 
 then
  begin
   sg.moverow(sg.row,sg.row + 1);
//   player.tracknum := player.tracknum + 1;
//   if sg.datacols[0][sg.row] = '      >' then player.tracknum := player.tracknum + 1;
   updatepl;
  end; 
end;

// ======================================================= 
//               clear playlist 
// ======================================================= 
procedure tmainfo.on_clearplaylist(const sender: TObject);
begin
 sg.clear;
 player.playlist.clear;
 player.tracknum := -1;
end;

// ======================================================= 
//               set repeat playlist 
// ======================================================= 
procedure tmainfo.on_setrepeatplaylist(const sender: TObject; var avalue: Boolean; var accept: Boolean);
begin  player.repeatplaylist := avalue;
end;

// ======================================================= 
//               set shuffle playlist 
// ======================================================= 
procedure tmainfo.on_shuffleplaylist(const sender: TObject; var avalue: Boolean;var accept: Boolean);
begin  player.shuffleplaylist := avalue;
end;

// ======================================================= 
//               update playlist 
// ======================================================= 
procedure  tmainfo.updatepl;
var  i : integer;
    sl : tstringlist;
begin
 sl := tstringlist.create;
 for i := 0 to sg.rowcount - 1 do sl.add(sg.datacols[2][i]);
 player.playlist.clear;
 player.playlist.assign(sl);
 sl.free;
end;

// ======================================================= 
//               open play list - enter point
// ======================================================= 
procedure tmainfo.on_openplaylist(const sender: TObject);
var s : array of msestring;
  y,i : integer;
   sl : tstringlist; 
begin
 tfiledialog1.controller.filter := '"*.pls" "*.m3u" "*.kpl" "*.asx"';
 if tfiledialog1.execute = mr_Ok then
 begin
  s := tfiledialog1.controller.filenames;
  sl:= tstringlist.create;
  sg.rowcount := 0;
  for i := 0 to high(s) do
   begin
     if extractfileext(s[i]) = '.pls' then openpls_playlist(s[i], sl);
     if extractfileext(s[i]) = '.m3u' then openm3u_playlist(s[i], sl);
     if extractfileext(s[i]) = '.kpl' then openkpl_playlist(s[i], sl);
     if extractfileext(s[i]) = '.asx' then openasx_playlist(s[i], sl);
     
     if sl.count > 0 then
     for y := 0 to sl.count - 1 do
     begin
       sg.rowcount := sg.rowcount + 1;
       sg.datacols[1][sg.rowcount - 1] := extractfilename(sl[y]);
       sg.datacols[2][sg.rowcount - 1] := sl[y];
     end;  
     updatepl;
   end;
  sl.free; 
 end; 
end;

// =============================================================================
//               play from playlist (duble click on playlist)
// =============================================================================
procedure tmainfo.on_dblclickeventonplaylist(const sender: TObject;  var info: celleventinfoty);
begin
 if sg.rowcount = 0 then exit;
 if iscellclick(info,[ccr_dblclick])      // if duble click ...
  then begin 
		 player.trackNum := sg.row;
         player.setvolume(round(mainfo.sl_volume.value * 100));
  		 player.play;
  	   end;
end;

// ======================================================= 
//               VIDEO SETTINGS
// =======================================================  
// ======================================================= 
//               show or hide video settings
// =======================================================  
procedure tmainfo.on_showvideosettings(const sender: TObject);
begin
 if  ttabwidget4.activepageindex = 1 
    then s_playlist.visible := not s_playlist.visible
    else s_playlist.visible := true;
    
 ttabwidget4.activepageindex := 1;
 if s_playlist.visible 
   then s_video.bounds_cx := width - s_playlist.bounds_cx
   else s_video.bounds_cx := width;
 on_resize(sender);  
end;

// ======================================================= 
// 				video options
// ======================================================= 
procedure tmainfo.on_setsetbrightness(const sender: TObject; var avalue: realty; var accept: Boolean);
begin  player.setbrightness(round(avalue * 200 - 100));
end;

procedure tmainfo.on_setcontrast(const sender: TObject; var avalue: realty; var accept: Boolean);
begin  player.setcontrast(round(avalue * 200 - 100));
end;

procedure tmainfo.on_setgamma(const sender: TObject; var avalue: realty;var accept: Boolean);
begin  player.setgamma(round(avalue * 200 - 100));
end;

procedure tmainfo.on_sethue(const sender: TObject; var avalue: realty;var accept: Boolean);
begin  player.sethue(round(avalue * 200 - 100));
end;

procedure tmainfo.on_setsaturation(const sender: TObject; var avalue: realty;var accept: Boolean);
begin  player.setsaturation(round(avalue * 200 - 100));
end;

// ======================================================= 
// 			video options to default levels
// ======================================================= 
procedure tmainfo.on_setvideooptionstodefault(const sender: TObject);
begin
  sl_brightness.value := 0.5;    main.player.setbrightness(round(sl_brightness.value * 200 - 100)); 
  sl_contrast.value := 0.5;      main.player.setcontrast(round(sl_contrast.value * 200 - 100));
  sl_gamma.value := 0.5;         main.player.setgamma(round(sl_gamma.value * 200 - 100));
  sl_hue.value := 0.5;           main.player.sethue(round(sl_hue.value * 200 - 100));
  sl_saturation.value := 0.5;    main.player.setsaturation(round(sl_saturation.value * 200 - 100));
end;

// ======================================================= 
//               MY PLAYLISTS
// ======================================================= 
// ======================================================= 
//               Load "My playlists"                       
// ======================================================= 
procedure tmainfo.loadplaylists(const sender : tobject);
var fs : tsearchrec;
begin
 sg_pl.rowcount := 0;
 findfirst('playlists' + separator + '*', faanyfile, fs);
 repeat
  if (fs.name = '.')or(fs.name = '..')or(fs.name = '') then continue;
  sg_pl.rowcount := sg_pl.rowcount + 1;
  sg_pl.datacols[0][sg_pl.rowcount - 1] := extractfilename(fs.name);
 until findnext(fs) <> 0;
 l_playlist_count.caption := inttostr(sg_pl.rowcount); 
end;

// ======================================================= 
//               delete playlist from my playlist                 
// ======================================================= 
procedure tmainfo.delete_playlist_form_list(const sender: TObject);
begin
 deletefile('playlists' + separator + sg_pl.datacols[0][sg_pl.row]);
 sg_pl.deleterow(sg_pl.row);
end;

// ======================================================= 
//               open playlist from my playlist  (dbl click)               
// ======================================================= 
procedure tmainfo.onchooseplaylistformmyplaylists(const sender: TObject; var info: celleventinfoty);
begin
 if sg_pl.rowcount = 0 then exit;
 if iscellclick(info,[ccr_dblclick])      // if duble click ...
  then on_openplaylist_from_myplaylists(sender);
end;

// ======================================================= 
//               open playlist from my playlist  (button)               
// ======================================================= 
procedure tmainfo.on_openplaylist_from_myplaylists(const sender: TObject);
var    sl : tstringlist;
        y : integer;
begin
  on_clearplaylist(sender);
  sg.rowcount := 0;
		
  if sg_pl.row < 0 then
          begin
            showmessage(pchar('Выберите плей-лист, пожалуйста!'));
            exit;
          end;
  sl:= tstringlist.create;
		
  openpls_playlist('playlists' + separator + sg_pl.datacols[0][sg_pl.row], sl);
        
  for y := 0 to sl.count - 1 do
 	    	begin
  	    	 sg.rowcount := sg.rowcount + 1;
   	    	 sg.datacols[1][sg.rowcount - 1] := extractfilename(sl[y]);
    	     sg.datacols[2][sg.rowcount - 1] := sl[y];
     		end;  
  updatepl;
  player.tracknum := 0;
  sl.free;
  on_showplaylist(sender);
end;

// ======================================================= 
//               SETTINGS
// ======================================================= 
// ======================================================= 
//               allow play next track
// ======================================================= 
procedure tmainfo.on_setNextTrackAllow(const sender: TObject; var avalue: Boolean; var accept: Boolean);
begin player.PlayNextTrackAllow := avalue;
end;

// ======================================================= 
//               allow to mplayer indexing tracks
// ======================================================= 
procedure tmainfo.on_setindexing(const sender: TObject; var avalue: Boolean; var accept: Boolean);
begin player.indexing := avalue;
end;

// ======================================================= 
//               always caching (include local files)
// ======================================================= 
procedure tmainfo.on_allowalwayscaching(const sender: TObject; var avalue: Boolean; var accept: Boolean);
begin player.alwaysCaching := avalue;
end;

// ======================================================= 
//               set audio output
// ======================================================= 
procedure tmainfo.on_setaudioOutput(const sender: TObject;var avalue: msestring; var accept: Boolean);
begin
 player.audiooutput := avalue;
end;

// ======================================================= 
//               set video output
// ======================================================= 
procedure tmainfo.on_setvideooutput(const sender: TObject; var avalue: msestring; var accept: Boolean);
begin
 player.videooutput := avalue;
end;

// ======================================================= 
//               set cache size
// ======================================================= 
procedure tmainfo.on_setcache(const sender: TObject; var avalue: msestring; var accept: Boolean);
begin
 player.cache := avalue;
end;

// ======================================================= 
//               set path to mplayer
// ======================================================= 
procedure tmainfo.on_choosemplayer(const sender: TObject);
begin
 tfiledialog1.controller.filter := '';
 if tfiledialog1.execute = mr_Ok then
   begin
     e_mplayer.text := tfiledialog1.controller.filename;
     player.mplayer := tfiledialog1.controller.filename;
   end;
end;

// ======================================================= 
//               get full output (mplayer and alsmplayer)
// ======================================================= 
procedure tmainfo.on_addtodebugmplayeroutput(const sender: TObject; var avalue: Boolean; var accept: Boolean);
begin
 main.player.AddMplayerMessagesToDebug := avalue;
end;


// ======================================================= 
//               ONLINE RADIO AND TV CHANELS
// ======================================================= 
// ======================================================= 
//               Load chanels playlist - enter point       
// ======================================================= 
procedure tmainfo.loadchanels;
begin
 radiochanelscount := 0;
 tvchanelscount := 0;

 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 tree.itemlist.add(tmynode.create);
 
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 tree2.itemlist.add(tmynode.create);
 
 loadchanelsfile('chanels' +  {$ifdef mswindows}'\'{$endif}{$ifdef linux}'/'{$endif} + 'chanels.conf');
// loadchanelsfile('chanels/export_all_utf8.txt');
 
 l_radiochenelscount.caption := inttostr(radiochanelscount);
 l_tvchenelscount.caption := inttostr(tvchanelscount);
 
end;

// ======================================================= 
//               Load file with chanels to collection      
// ======================================================= 
procedure tmainfo.loadchanelsfile(fname : string);
var  fi : tinifile;
     sl : tstringlist;
      i : integer;
     tr : ttreeitemedit;
     cc : integer;
begin
 sl := tstringlist.create;
 fi := tinifile.create(fname);
 fi.readsections(sl);
 
// if fname = 'chanels/chanels.conf' then l_radio_count.caption := inttostr(sl.count);
// if fname = 'chanels/export_all_utf8.txt' then l_tv_count.caption := inttostr(sl.count);

 for i := 0 to sl.count - 1 do
  begin 
 
   if fi.readstring(sl[i],'type','') = 'radio' then begin tr := tree; cc := radiochanelscount; end;
   if fi.readstring(sl[i],'type','') = 'tv' then begin tr := tree2; cc := tvchanelscount; end;
   
   if fi.readstring(sl[i],'category','') = 'music' then 
	with tmynode(tr[0]) do begin
 	 caption:= 'music';
	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
    end;
 
   if fi.readstring(sl[i],'category','') = 'news' then 
	 with tmynode(tr[1]) do begin
 	 caption:= 'news';
  	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	end;

   if fi.readstring(sl[i],'category','') = 'sport' then 
	 with tmynode(tr[2]) do begin
	 caption:= 'sport';
	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	 end;

   if fi.readstring(sl[i],'category','') = 'child' then 
	 with tmynode(tr[3]) do begin
	  caption:= 'child';
	  add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	 end;

   if fi.readstring(sl[i],'category','') = 'sitizen' then 
	 with tmynode(tr[4]) do begin
	 caption:= 'sitizen';
	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	 end;

   if fi.readstring(sl[i],'category','') = 'religion' then 
	 with tmynode(tr[5]) do begin
	 caption:= 'religion';
	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	 end;

   if fi.readstring(sl[i],'category','') = 'others' then 
	 with tmynode(tr[6]) do begin
	 caption:= 'others';
	 add(1,tmynode);
     items[count - 1].caption:= {$ifdef mswindows}utf8toansi(sl[i]){$endif}{$ifdef linux}sl[i]{$endif};
     inc(cc);
	 end;

   if fi.readstring(sl[i],'type','') = 'radio' then radiochanelscount := cc;
   if fi.readstring(sl[i],'type','') = 'tv' then tvchanelscount := cc;
 end;

 fi.free;
 sl.free; 
end;

// ======================================================= 
//               add chanel to playlist (dbl click)
// ======================================================= 
procedure tmainfo.on_choosechanel(const sender: TObject; var info: celleventinfoty);
var  fi : tinifile;
    chn : string; 
begin
 if iscellclick(info,[ccr_dblclick])      // if duble click ...
 then
     begin
       if (sender as twidgetgrid).name = 'grid' then  chn := tree.items[tree.item.index].caption;
       if (sender as twidgetgrid).name = 'grid2' then chn := tree2.items[tree2.item.index].caption;
	   fi := tinifile.create('chanels' +  {$ifdef mswindows}'\'{$endif}{$ifdef linux}'/'{$endif} + 'chanels.conf');
       if fi.readstring(ansitoutf8(chn), 'url' ,'') = '' then 
        BEGIN
           fi.free;
		   fi := tinifile.create('chanels' +  {$ifdef mswindows}'\'{$endif}{$ifdef linux}'/'{$endif} + 'export_all_utf8.txt');
	   {$ifdef mswindows}
           if fi.readstring(ansitoutf8(chn), 'url' ,'') = '' then exit;
	   {$endif}

	   {$ifdef linux}
       if fi.readstring(chn, 'url' ,'') = '' then exit;  // if no url !
	   {$endif}
        END;  // if no url !
	   
       on_clearplaylist(sender);
       sg.rowcount := sg.rowcount + 1;
       sg.datacols[1][sg.rowcount - 1] := chn;
       sg.datacols[2][sg.rowcount - 1] := fi.readstring(chn, 'url' ,'');
       fi.free;  
       updatepl; 
       player.trackNum := 0;
       ttabwidget4.activepageindex := 0;
       application.processmessages;
       player.play;   
     end;	
end;

// ======================================================= 
//               TV
// ======================================================= 
procedure tmainfo._on_showtvchannellist(const sender: TObject);
begin
 if ttabwidget1.activepageindex <> 0
    then begin
          ttabwidget1.activepageindex := 0;
          s_playlist.visible := true;
          ttabwidget4.activepageindex := 2;
          s_video.bounds_cx := width - s_playlist.bounds_cx;
          exit;
         end; 

 if  ttabwidget4.activepageindex = 2 
     then s_playlist.visible := not s_playlist.visible
     else s_playlist.visible := true;

 ttabwidget4.activepageindex := 2;
 if s_playlist.visible 
    then s_video.bounds_cx := width - s_playlist.bounds_cx
    else s_video.bounds_cx := width;
 
 player.stop;
 player.mode:=__tv;
 s_playbuttons.visible := false;
 player.OpenTV();
 on_resize(sender);
end;
  

procedure SaveChannel();
var
i:integer;
begin
sc:=TIniFile.Create(CFGChannelsName);
sc.WriteInteger('TVcount','Count',mainfo.st.rowcount);
for i:=1 to player.ListofChanell.Count do
begin
sc.WriteString('TV'+inttostr(i),'tvname',player.ListofChanell.GetData(i-1).Name);
sc.WriteInteger('TV'+inttostr(i),'freqtv',player.ListofChanell.GetData(i-1).Freq);
Sc.WriteString('TV'+inttostr(i),'normtv',tvstr[player.ListofChanell.GetData(i-1).Norm]);
end;
sc.WriteInteger('TVcount','Count',mainfo.st.rowcount);
sc.free;
end;

//Добавить канал
procedure tmainfo.on_addchanell(const sender: TObject);
var
tvd:TTVData;
i:integer;
begin
tvd.Freq:=e_freqtv.value;
tvd.Norm:=StrToTvNorm(e_normtv.value);
tvd.Name:=e_tvname.value;
player.ListofChanell.AddItem(tvd);
st.rowcount := st.rowcount + 1;
st.datacols[0][st.rowcount-1]:=e_tvname.value;
st.datacols[1][st.rowcount-1] :=inttostr(e_freqtv.value) ;
st.datacols[2][st.rowcount-1]:=e_normtv.value;
SaveChannel();
end;

//Удалить канал
procedure tmainfo.on_deletechanell(const sender: TObject);
begin
st.deleterow(st.row);
player.ListofChanell.RemoveItem(CountSelectionGrid);
SaveChannel();
end;

procedure tmainfo.on_setchanneltv(const sender: TObject);
var
idata:TTVData;
begin
st.datacols[0][CountSelectionGrid]:=e_tvname.value;
st.datacols[1][CountSelectionGrid] :=inttostr(e_freqtv.value) ;
st.datacols[2][CountSelectionGrid]:=e_normtv.value;

idata.Name:=e_tvname.value;
idata.Freq:=e_freqtv.value ;
idata.Norm:=StrToTvNorm(e_normtv.value);
player.stop;
player.ListofChanell.SetData(CountSelectionGrid,idata);
player.opentv;
player.SetChannelByfreq(player.ListofChanell.GetData(CountSelectionGrid).Freq);
player.SetChannelNorm(player.ListofChanell.GetData(CountSelectionGrid).Norm);
SaveChannel();
end;

procedure tmainfo.on_dblclickeventonplaylist2(const sender: TObject;var info: celleventinfoty);
var 
  sf: focuscellactionty;
   t: twidgetgrid;
begin

 if iscellclick(info,[ccr_dblclick])      // if duble click ...
  then
  begin
   //Set Channel
   player.SetChannelByfreq(player.ListofChanell.GetData(CountSelectionGrid).Freq);
   player.SetChannelNorm(player.ListofChanell.GetData(CountSelectionGrid).Norm);
  end; 
   sf := info.selectaction;
   t  := twidgetgrid(Sender);
if (sf = fca_focusinforce) or (sf = fca_focusin) or (sf = fca_entergrid) then
begin
if (info.cell.col <= t.datacols.Count) then
 begin
  if (info.cell.col >= 0) then
  begin
   if (info.cell.row <= t.rowcount) then
   begin
    if (info.cell.row >= 0) then
    begin
     //выделенная ячейка
     CountSelectionGrid := info.cell.row;
     e_tvname.value:=st.datacols[0][CountSelectionGrid];
     e_freqtv.value:=StrToInt(st.datacols[1][CountSelectionGrid]);
     e_normtv.value:=st.datacols[2][CountSelectionGrid];
    end;
   end;
  end;
 end;
end;
end;

// ======================================================= 
//               ON-line chanels
// ======================================================= 
procedure tmainfo.on_showonline(const sender: TObject);
begin

 if ttabwidget1.activepageindex <> 0
    then begin
          ttabwidget1.activepageindex := 0;
          s_playlist.visible := true;
          ttabwidget4.activepageindex := 3;
          s_video.bounds_cx := width - s_playlist.bounds_cx;
          exit;
         end; 

 if  ttabwidget4.activepageindex = 3 
     then s_playlist.visible := not s_playlist.visible
     else s_playlist.visible := true;

 ttabwidget4.activepageindex := 3;
 if s_playlist.visible 
    then s_video.bounds_cx := width - s_playlist.bounds_cx
    else s_video.bounds_cx := width;
 on_resize(sender);
end;

procedure tmainfo.on_cleardebug(const sender: TObject);
begin
 sg_debug.rowcount := 0;
end;

procedure tmainfo.on_sendcmdtomplayer(const sender: TObject);
begin
 player.sendcommandtomplayer(e_cmd.text);
end;


end.
